package main.java.jcg.ssowmya.demo.typecast;

public class Student extends UniversityUser{
    private boolean enrollmentStatus;
    private String college;
    private String classification;

    public Student(String universityId, String name, String affiliation, String email, boolean enrollmentStatus, String college, String classification) {
        super(universityId, name, affiliation, email);
        this.enrollmentStatus = enrollmentStatus;
        this.college = college;
        this.classification = classification;
    }

    public boolean isEnrollmentStatus() {
        return enrollmentStatus;
    }

    public void setEnrollmentStatus(boolean enrollmentStatus) {
        this.enrollmentStatus = enrollmentStatus;
    }

    public String getCollege() {
        return college;
    }

    public void setCollege(String college) {
        this.college = college;
    }

    public String getClassification() {
        return classification;
    }

    public void setClassification(String classification) {
        this.classification = classification;
    }
    public boolean validateStudent() {
        boolean isValidStudent = false;
        boolean isValidUniversityUser = new ValidateUniversityUser().validateUniversityId(this);
        if(!isValidUniversityUser)
            return isValidUniversityUser;
        else {
            //Perform student specific validations
            if(classification!=null && !"".equals(classification))
            {
                switch(classification) {
                    case "FR":
                    case "SO":
                    case "JR":
                    case "SR":
                        isValidStudent = true;
                        break;

                    default:
                        break;
                }
            }
        }
        return isValidUniversityUser && isValidStudent;
    }

    public boolean getLibraryAccess() {
        return validateStudent() && enrollmentStatus;
    }

}
