package test.java.jcg.ssowmya.demo.typecast;

import main.java.jcg.ssowmya.demo.typecast.Staff;
import main.java.jcg.ssowmya.demo.typecast.Student;
import main.java.jcg.ssowmya.demo.typecast.UniversityUser;
import org.junit.Test;

import java.math.BigDecimal;

import static org.junit.Assert.*;

public class ObjectTypeCastTest {
    @Test
    public void testUpcastingStudentToUniversityUser() {
        UniversityUser universityUser = new UniversityUser("1234","Test UnivUser","Part time student","testunivuser@jcg.com");
        Student student = new Student("12345",
                "Test Student",
                "Student",
                "teststudent@jcg.com",true,
                "BE",
                "Freshman");
        universityUser = student;
        assertEquals("12345",universityUser.getUniversityId());
        //Compiler Error: universityUser.getCollege();
    }
    @Test
    public void testDowncastingUniversityUserToStaff() {
        UniversityUser universityUser  = new Staff("123456",
                "Test Staff",
                "Staff",
                "teststaff@jcg.com",
                "Full time",
                "Information Technologies",
                "123-456-7899");
        Staff staff = null;
        if(universityUser instanceof Staff)
            staff = (Staff)universityUser;
        assertEquals("123456", staff.getUniversityId());
        assertEquals("Full time", staff.getEmployeeType());
    }
    @Test
    public void testClassCast1UniversityUserToStaff() {
        UniversityUser universityUser  = new Student("12345",
                "Test Student",
                "Student",
                "teststudent@jcg.com",true,
                "BE",
                "Freshman");
        assertThrows(ClassCastException.class, ()->{Staff staff = (Staff)universityUser;});
    }
    @Test
    public void testClassCast2UniversityUserToStaff() {
        UniversityUser universityUser = new UniversityUser("1234","Test UnivUser","Part time student","testunivuser@jcg.com");
        assertThrows(ClassCastException.class,() -> {
            Staff staff = (Staff)universityUser;});
    }
    @Test
    public void testOverride() {
        UniversityUser universityUser1  = new Student("12345",
                "Test Student",
                "Student",
                "teststudent@jcg.com",false,
                "BE",
                "Freshman");
        UniversityUser universityUser2  = new Staff("UID123456",
                "Test Staff",
                "Staff",
                "teststaff@jcg.com",
                "F/T",
                "Information Technologies",
                "123-456-7899");
        assertFalse(universityUser1.getLibraryAccess());
        assertTrue(universityUser2.getLibraryAccess());
    }
    @Test
    public void testCastMethod() {
        UniversityUser universityUser  = new Student("UID12345",
                "Test Student",
                "Student",
                "teststudent@jcg.com",false,
                "BE",
                "Sophomore");
        Staff staff = null;
        Student student = null;
        if(universityUser instanceof Staff)
            staff = Staff.class.cast(universityUser);
        else if(universityUser instanceof Student)
            student = Student.class.cast(universityUser);
        assertNull(staff);
        assertNotNull(student);
    }
}
