package jcg.ssowmya.demo.typecast;


import org.junit.Test;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertNotEquals;

public class PrimitiveTypeCastTest {
    @Test
    public void testImplicitShortToIntCasting() {
        short shortVar = 45;
        int castVar= shortVar;
        System.out.println("Short val : "+shortVar);
        System.out.println("Int val : "+castVar);
        assertEquals(shortVar,castVar);
    }

    @Test
    public void testImplicitIntToFloatCasting() {
        int intVar = Integer.MIN_VALUE;
        float floatVar= intVar;
        System.out.println("Int val : "+intVar);
        System.out.println("Float val : "+floatVar);
        assertEquals(intVar,floatVar,0);
    }
    @Test
    public void testCharToShortCasting() {
        char unsignedCharVar= 'a';
        System.out.println("Char val : "+unsignedCharVar);
        short signedShortVar = (short)unsignedCharVar;
        System.out.println("Short val : "+signedShortVar);
        assertEquals(unsignedCharVar,signedShortVar);

    }

    @Test
    public void testSignedShortToCharCasting() {

        short signedShortVar = -97;
        System.out.println("Short val : "+signedShortVar);
        char unsignedCharVar= (char)signedShortVar;
        System.out.println("Char val : "+unsignedCharVar);
        assertNotEquals(signedShortVar,unsignedCharVar);
    }

    @Test
    public void testUnSignedShortToCharCasting() {

        short unsignedShortVar = 97;
        System.out.println("Short val : "+unsignedShortVar);
        char unsignedCharVar= (char)unsignedShortVar;
        System.out.println("Char val : "+unsignedCharVar);
        assertEquals(unsignedCharVar,unsignedShortVar);
    }
    @Test
    public void testExplicitFloatToIntCasting() {
        float floatVar = Float.MAX_VALUE;
        int intVar= (int)floatVar;
        System.out.println("Float val : "+floatVar);
        System.out.println("Int val : "+intVar);
        assertNotEquals(intVar,floatVar,0);
    }
}
